package stamp.math;
import stamp.util.text.*;

/**
 * CORDIC
 *
 * program to demonstrate CORDIC techniques on Javelin Stamp
 * adapted from Tracy Allen cordic examples
 */

public class cordic_test {

  public static void main() {
    Format.printf("Test program CORDIC\n\n");
    sin_cos_atn(0);
    sin_cos_atn(1);
    sin_cos_atn(4);
    sin_cos_atn(5);
    sin_cos_atn(10);
    sin_cos_atn(150);
    sin_cos_atn(300);
    sin_cos_atn(450);
    sin_cos_atn(600);
    sin_cos_atn(750);
    sin_cos_atn(890);
    sin_cos_atn(894);
    sin_cos_atn(895);
    sin_cos_atn(898);
    sin_cos_atn(899);
    sin_cos_atn(900);
    sin_cos_atn(901);
    sin_cos_atn(902);
    sin_cos_atn(-1);
    sin_cos_atn(-4);
    sin_cos_atn(-5);
    sin_cos_atn(-10);
    sin_cos_atn(-150);
    sin_cos_atn(-300);
    sin_cos_atn(-450);
    sin_cos_atn(-600);
    sin_cos_atn(-750);
    sin_cos_atn(-890);
    sin_cos_atn(-894);
    sin_cos_atn(-895);
    sin_cos_atn(-898);
    sin_cos_atn(-899);
    sin_cos_atn(-900);
    sin_cos_atn(-901);
    sin_cos_atn(-902);
    Format.printf("program finished\n");
    while (true) ;
  }

  static void sin_cos_atn(int a) {
    int w,x,y,z;
    w = cordic.tan(a);
    x = cordic.cos(a);
    y = cordic.sin(a);
    z = cordic.atan2(y,x);
    print(a,w,x,y,z);
  }

  //print cos,sin,tan,atan
  private static void print(int a, int w, int x, int y, int z) {
    Format.printf("x=cos(");
    if (a<0) Format.printf("-");
    else Format.printf(" ");
    Format.printf("%2d.",UnsignedIntMath.abs(a)/10);
    Format.printf("%d) = ",UnsignedIntMath.abs(a)%10);
    pr_4dec(x);
    Format.printf("   y=sin(");
    if (a<0) Format.printf("-");
    else Format.printf(" ");
    Format.printf("%2d.",UnsignedIntMath.abs(a)/10);
    Format.printf("%d) = ",UnsignedIntMath.abs(a)%10);
    pr_4dec(y);
    Format.printf("   tan(");
    if (a<0) Format.printf("-");
    else Format.printf(" ");
    Format.printf("%2d.",UnsignedIntMath.abs(a)/10);
    Format.printf("%d) = ",UnsignedIntMath.abs(a)%10);
    pr_2dec(w);
    Format.printf("   atan2(y,x) = ");
    pr_1dec(z);
    Format.printf("\n");
  }

  //print with 4 decimals
  private static void pr_4dec(int i) {
    if (i<0) Format.printf("-");
    else Format.printf(" ");
    Format.printf("%d.",UnsignedIntMath.abs(i)/10000);
    Format.printf("%04d",UnsignedIntMath.abs(i)%10000);
  }

  //print with 2 decimals
  private static void pr_2dec(int i) {
    if (i<0) Format.printf("-");
    else Format.printf(" ");
    Format.printf("%3d.",UnsignedIntMath.abs(i)/100);
    Format.printf("%02d",UnsignedIntMath.abs(i)%100);
  }

  //print with 1 decimal
  private static void pr_1dec(int i) {
    if (i<0) Format.printf("-");
    else Format.printf(" ");
    Format.printf("%3d.",UnsignedIntMath.abs(i)/10);
    Format.printf("%d",UnsignedIntMath.abs(i)%10);
  }

}


